use crate::canvas::shader::common::CompiledGraphicsPipeline;

pub mod common;
pub mod generic_shader;
pub mod text_shader;
pub mod dynamic_vertex;

use crate::canvas::shader::common::*;
use crate::canvas::shader::generic_shader::*;
use crate::canvas::shader::text_shader::*;
use crate::canvas::shader::dynamic_vertex::*;


use vulkano::pipeline::shader::{SpecializationConstants, SpecializationMapEntry};

#[repr(C)]
#[derive(Default, Debug, Clone)]
/// Specialization constants which can be passed to the shader. Pretty much placeholder ATM
struct ShaderSpecializationConstants {
    first_constant: i32,
    second_constant: u32,
    third_constant: f32,
}

unsafe impl SpecializationConstants for ShaderSpecializationConstants {
    fn descriptors() -> &'static [SpecializationMapEntry] {
        static DESCRIPTORS: [SpecializationMapEntry; 3] = [
            SpecializationMapEntry {
                constant_id: 0,
                offset: 0,
                size: 4,
            },
            SpecializationMapEntry {
                constant_id: 1,
                offset: 4,
                size: 4,
            },
            SpecializationMapEntry {
                constant_id: 2,
                offset: 8,
                size: 4,
            },
        ];

        &DESCRIPTORS
    }
}